/******************************************************************************
** Copyright (c) 2013-2016 Intel Corporation All Rights Reserved
**
** Licensed under the Apache License, Version 2.0 (the "License"); you may not
** use this file except in compliance with the License.
**
** You may obtain a copy of the License at
**     http://www.apache.org/licenses/LICENSE-2.0
**
** Unless required by applicable law or agreed to in writing, software
** distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
** WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
**
** See the License for the specific language governing permissions and
** limitations under the License.
**
******************************************************************************/

#pragma once

#include "Dptf.h"
#include "DomainWorkItem.h"
#include "esif_sdk_iface_app.h"

class WIDomainCreate : public DomainWorkItem
{
public:

    WIDomainCreate(DptfManagerInterface* dptfManager, UIntN participantIndex, UIntN domainIndex,
        const AppDomainDataPtr domainDataPtr, Bool domainEnabled, Bool* domainCreated);
    virtual ~WIDomainCreate(void);

    virtual void execute(void) override final;

private:

    const AppDomainDataPtr m_domainDataPtr;
    const Bool m_domainEnabled;
    Bool* m_domainCreated;
};